function extractValue(s, name)

	pos = string.find(s, name.."=", 1, true)
	if pos == nil then

		return nil

	end
	pos = pos+#name+1
	pos2 = string.find(s, ";", pos, true)
	if pos2 == nil then

		return string.sub(s, pos)

	else

		return string.sub(s, pos, pos2-1)

	end

end
function extractLogin(s)

	user = extractValue(s, "user")
	if user == nil then return nil end
	pass = extractValue(s, "pass")
	if pass == nil then return nil end
	return user, pass

end



innerState = 0
function init()
	API.CreateComputer("secretary" , 100,   0, 150)
	API.CreateComputer("president" ,   0,   0, 255)
	API.CreateComputer("citizen" ,    80, 200,   0)
	API.CreateComputer("first lady",  80,   0, 200)
	API.CreateComputer("control",    140,   0,   0)
	API.CreateComputer("CA",         200,  80,   0)
	API.CreateComputer("light",      200, 200,   0)
	API.CreateComputer("iran army",   30, 150,   0)
	API.CreateComputer("drones",       0,   0,   0)
	API.CreateGameState()
	API.GameStateOnline(0, "Me")
	API.GameStateOnline(0, "secretary")
	API.GameStateOnline(0, "president")
	API.AddPermission() -- send messages
	API.CreateGameState()
	API.GameStateOnline(1, "Me")
	API.GameStateOnline(1, "secretary")
	API.GameStateOnline(1, "control")
	API.GameStateOnline(1, "citizen")
	API.GameStateOnline(1, "light")
	API.AddKey() -- 1
	API.CreateGameState()
	API.GameStateOnline(2, "Me")
	API.GameStateOnline(2, "light")
	API.GameStateOnline(2, "control")
	API.GameStateOnline(2, "secretary")
	API.CreateGameState()
	API.GameStateOnline(3, "Me")
	API.GameStateOnline(3, "control")
	API.AddPermission() -- cancel
	API.CreateGameState()
	API.GameStateOnline(4, "Me")
	API.GameStateOnline(4, "control")
	API.GameStateOnline(4, "secretary")
	API.GameStateOnline(4, "president")
	API.GameStateOnline(4, "first lady")
	API.GameStateOnline(4, "citizen")
	API.AddKey() -- 2
	API.CreateGameState()
	API.GameStateOnline(5, "Me")
	API.GameStateOnline(5, "secretary")
	API.GameStateOnline(5, "president")
	API.GameStateOnline(5, "first lady")
	API.AddPermission() -- fake sender
	API.CreateGameState()
	API.GameStateOnline(6, "Me")
	API.GameStateOnline(6, "secretary")
	API.GameStateOnline(6, "president")
	API.GameStateOnline(6, "CA")
	API.AddKey() -- 3
	API.CreateGameState()
	API.GameStateOnline(7, "Me")
	API.GameStateOnline(7, "CA")
	API.GameStateOnline(7, "secretary")
	API.GameStateOnline(7, "president")
	API.GameStateOnline(7, "drones")
	API.GameStateOnline(7, "first lady")
	API.GameStateOnline(7, "citizen")
	API.GameStateOnline(7, "iran army")
	API.GameStateOnline(7, "light")
	API.GameStateOnline(7, "control")

end
function init_0()
	API.Notify("You just moved to your new home.\nYou notice two irritating\nthings: The house at the end of the\nroad where light is\nnever switched off and\nyour aibility to read these messages")
	innerState = 0
end
function gameState_0()
	if innerState == 0 and API.ActiveNotification() == 0 then

		innerState = 1
		API.SendMsg("secretary", "president", "Sir, the new drones are here", 0)
	elseif innerState == 1 and API.MsgAvailable("president") ~= 0 then

		innerState = 2
		API.MsgNext("president")
		API.SendMsg("president", "secretary", "Great, let's have some fun", 0)
	elseif innerState == 2 and API.MsgAvailable("secretary") ~= 0 then

		API.MsgNext("secretary")
		API.SendMsg("secretary", "president", "Ok...", 3)
		innerState = 3

	elseif API.MsgAvailable("president") ~= 0 then

		API.MsgNext("president")
		API.ChangeState(1)

	end

end
function init_1()
	API.Notify("World domination seems nearer\nthan you ever dreamed.\nWelcome to\nMAN IN THE MIDDLE")
	innerState = 0
	API.SetTimeout("lightRequest", 10000, 1)
	API.SetTimeout("sendMsg0", 3000, 1)
end
function sendMsg0()
	API.SendMsg("citizen", "secretary", "Sir, I have to tell you something IMPORTANT...", 0)
end
requestActive = true
function lightRequest()

	if requestActive then
		API.SendMsg("control", "light", "Dimto "..(10*math.floor(math.random(4, 10))), 1)
		API.SetTimeout("lightRequest", 10000, 1)
	end
end
function gameState_1()
	while API.MsgAvailable("secretary") ~= 0 do
		local content = API.MsgContent("secretary")
		local sender = API.MsgSender("secretary")
		if sender == "citizen" then

			if string.find(content, "IMPORTANT", 0, true) then

				API.SendMsg("secretary", "citizen", "I see, you have a key. Please encrypt your message.", 0)
			else
				API.SendMsg("secretary", "citizen", "we gonna check this", 1)
			end
		elseif sender == "Me" then
			if string.find(string.lower(content), "important", 0, true) then
				API.SendMsg("secretary", "Me", "You don't have a key, do you? Take this one.", 0)
				API.ChangeState(2)
			else
				API.SendMsg("secretary", "Me", "Can I help you?", 0)
			end
		end
		API.MsgNext("secretary")
	end
	while API.MsgAvailable("citizen") ~= 0 do

		if API.MsgSender("citizen") == "secretary" and API.MsgKey("citizen") == 0 then
			API.SendMsg("citizen", "secretary", "Yersterday, I saw an UFO", 1)
		end
		API.MsgNext("citizen")
	end
end

responded = false
function init_2()
	API.Notify("You got the key.")
	innerState = 0
	API.SetTimeout("lightRequest", 10000, 1)
	requestActive = true
	responded = false
	API.SetTimeout("requestResponse", 6000, 1)
end
function requestResponse()
	if not responded then
		API.SendMsg("secretary", "Me", "Sir?", 1)
		API.SetTimeout("requestResponse", 6000, 1)
	end
end

function gameState_2()
	while API.MsgAvailable("secretary") ~= 0 do

		if API.MsgSender("secretary") == "Me" then

			if API.MsgKey("secretary") == 1 then

				API.SendMsg("secretary", "Me", "we gonna check this", 1)
				if not responded then

					API.SendMsg("control", "secretary", "We now fixed the LOGIN bug on light control server", 1)
					responded = true
				end
	
			else
	
				API.SendMsg("secretary", "Me", "Please encrypt your message", 0)
			end
		end
		API.MsgNext("secretary")

	end

	while API.MsgAvailable("light") ~= 0 do
 		if API.MsgKey("light") == 1 and API.MsgSender("light") == "Me" then
			if innerState == 0 then
				local user, pass
				user, pass = extractLogin(API.MsgContent("light"))
				if user and user == pass then
					API.SendMsg("light", "Me", "Login successful", 1)
					API.SetTimeout("showLightCommands", 1000, 1)
					innerState = 1
				else
					API.SendMsg("light", "Me", "LOGIN (user=?;pass=?)", 1)
				end
			else
				local content = string.lower(API.MsgContent("light"))
				if content == "switchoff" then
					API.SendMsg("light", "Me", "Switched light off. SHUTING DOWN NOW", 1)
					API.ChangeState(3)
				elseif string.find(content, "dimto") == nil then
						API.SendMsg("light", "Me", "Command not found", 1)
				end
			end
		end
		API.MsgNext("light")
	end
	while API.MsgAvailable("control") ~= 0 do

		API.SendMsg("control", "Me", "Do NOT touch my system, hacker!", 0)
		API.MsgNext("control")
	end
end
function showLightCommands()
	API.SendMsg("light", "Me", "Commands: Dimto <number>, Switchoff", 1)
end
function init_3()

	API.Notify("At the end of the road, you see\nthe house getting dark. Somebody inlights\na match and tries to find his way to\nthe cellar.")
	
end
function gameState_3()

	while API.MsgAvailable("control") ~= 0 do

		local key = API.MsgKey("control")
		local content = string.lower(API.MsgContent("control"))
		local user, pass
		user,pass = extractLogin(content)
		if user and pass then
			if user == "johnsmith" and pass == "1234" then
				API.SendMsg("control", "Me", "Login successful!", key)
				API.ChangeState(4)
			else
				API.SendMsg("control", "Me", "Login failed!", key)
			end
		elseif string.find(content, "login") ~= nil then
			API.SendMsg("control", "Me", "user=johnsmith;pass=1234", key)
		else
			API.SendMsg("control", "Me", "Login required", key)
		end
		API.MsgNext("control")
	end
end
function init_4()

	API.Notify("Great! By controlling the internet\nyou can cancel any message by clicking\nit right, if it has not been delivered\nyet.")
	innerState = 0

end
function gameState_4()
	
	if innerState == -1 and API.ActiveNotification() == 0 then

		API.ChangeState(4)
		return

	end
	if innerState == 0 then

		if API.ActiveNotification() == 0 then
			
			innerState = 1
			API.SetTimeout("sendMsg1", math.random(1000, 10000), 1)
			API.SetTimeout("sendMsg2", math.random(1000, 10000), 1)
			API.SetTimeout("sendMsg3", math.random(1000, 10000), 1)

		end
		return

	end
	while API.MsgAvailable("secretary") ~= 0 do

		if API.MsgSender("secretary") == "control" then

			API.SendMsg("secretary", "Me", "You are arrested", 0)
			API.Notify("You hacking activities have\nbeen discovered.\nGAME OVER")
			API.LockNotification()
			innerState = -1
		elseif API.MsgSender("secretary") == "citizen" then

			API.SendMsg("secretary", "citizen", "Rumors. If the president heard of this...", 1)

		else

			API.SendMsg("secretary", "Me", "Can I help you?", API.MsgKey("secretary"))
		end
		API.MsgNext("secretary")
	end
	while API.MsgAvailable("first lady") ~= 0 do

		local sender = API.MsgSender("first lady")
		local content = API.MsgContent("first lady")
		if sender == "Me" then

			if string.find(string.lower(content), "invasion") ~= nil then
				API.SendMsg("first lady", "president", "Barack, I have an important question to you", 0)

			else

				API.SendMsg("first lady", "Me", "Mind your own business!", 0)
			end
		elseif sender == "president" then

			if string.find(content, "key") then

				API.ChangeState(5)

			end
		end
		API.MsgNext("first lady")

	end
	while API.MsgAvailable("president") ~= 0 do

		if API.MsgSender("president") == "first lady" then

			API.SendMsg("president", "first lady", "Use this key.", 0)
		end
		API.MsgNext("president")
	end
end
function sendMsg1()
	API.SendMsg("control", "secretary", "I notified some strange activities here.", 1)
end
function sendMsg2()
	API.SendMsg("president", "first lady", "Sweetie, I will come home later, today", 0)
end
function sendMsg3()
	API.SendMsg("citizen", "secretary", "Sir, my relatives in Iran told me sth. about an invasion", 1)
end
function init_5()

	API.Notify("Sending keys through the internet\nis as insecure as unencrypted\ncomminucation. Of course, you\ncaught that key")
	innerState = 0
	passCnt = 0

end
function gameState_5()

	if innerState == 0 and API.ActiveNotification() == 0 then

		innerState = 1
		API.SendMsg("first lady", "president", "What about the Iran invasion?", 2)
	elseif innerState == 1 and API.MsgPop("president") ~= 0 then

		innerState = 2
		API.SendMsg("president", "first lady", "Rumors, don't care", 2)
		API.SetTimeout("sendMsg4", 2000, 1)

	elseif innerState == 2 and API.MsgPop("president") ~= 0 then

		innerState = 3
		API.SendMsg("president", "secretary", "Prepare them to be used", 1)
		API.SendMsg("president", "secretary", "OHWV FDOO LW RSHUDWLRQ LQKXPDQ", 1)
	elseif innerState == 3 and API.MsgPop("secretary") ~= 0 then

		innerState = 4
	
	elseif innerState == 4 and API.MsgPop("secretary") ~= 0 then

		API.SendMsg("secretary", "president", "OK", 1)
		innerState = 5

	elseif innerState == 5 and API.MsgPop("president") ~= 0 then

		API.GoOnline("iran army")
		API.SetTimeout("hackArmy", 5000, 1)
		innerState = 6

	elseif innerState > 5 then

		while API.MsgAvailable("secretary") ~= 0 do

			if API.MsgSender("secretary") == "Me" then

				API.SendMsg("secretary", "Me", "Can I help you?", API.MsgKey("secretary"))
			end
			API.MsgNext("secretary")

		end
		while API.MsgAvailable("iran army") ~= 0 do

			if API.MsgKey("iran army") ~= 1 or innerState > 7 then

				API.MsgNext("iran army")
				break

			end

			local content = API.MsgContent("iran army")
			local sender = API.MsgSender("iran army")

			if innerState == 7 and sender == "Me" then

				if string.find(string.lower(content), "prepare") ~= nil then
					API.SendMsg("iran army", "Me", "Preparing to defend US-Invasion", 1)
					innerState = 8
					API.GoOnline("light")
					API.GoOnline("control")

				else

					API.SendMsg("iran army", "Me", "Cannot understand your order", 1)

				end

			else
				local user, pass
				user, pass = extractLogin(content)
				if user then
	
					if user == "dictator" and pass == "dictator" then
	
						innerState = 7
						API.SendMsg("iran army", "Me", "Login successful", 1)
						API.SendMsg("iran army", "Me", "Expecting your orders (type \"Prepare\" to setup defense)", 1)
	
					end
	
				else
	
					API.SendMsg("iran army", "Me", "Login reqested", 1)
				end
			end
			API.MsgNext("iran army")

		end
		if innerState == 8 then

			while API.MsgAvailable("light") ~= 0 do
	
				if API.MsgKey("light") == 1 then
	
					local cmd = string.lower(API.MsgContent("light"))
					if string.find(cmd, "switchoff") ~= nil then
	
						API.Notify("You see the house turning\n black again")
						API.GoOffline("light")
	
						innerState = 9

					elseif string.find(cmd, "dimto") == nil then
						API.SendMsg("light", "Me", "Commands: Dimto <number>, Switchoff", 1)
					end
				end
				API.MsgNext("light")
			end
		end
		while API.MsgAvailable("control") ~= 0 do


			local key = API.MsgKey("control")

			if innerState < 9 then

				API.SendMsg("control", "Me", "keep you dirty fingers off my system, hacker", key)

			else

				local user, pass
				user, pass = extractLogin(API.MsgContent("control"))
				if user == "johnsmith" and pass == "1234" then

					API.ChangeState(6)

				else

					API.SendMsg("control", "Me", "Login failed", key)
				end

			end
			API.MsgNext("control")
		end
	end

end
function sendMsg4()
	API.SendMsg("secretary", "president", "The drones are ready to be used.", 1)
	API.SetTimeout("sendMsg5", 1000, 1)
end
function sendMsg5()
	API.SendMsg("secretary", "president", "They might be useful in the case of an iranian invasion.", 1)
end
function hackArmy()
	API.SendMsg("secretary", "iran army", "user=dictator;pass="..passCnt, 1)
	passCnt = passCnt+1
	API.SetTimeout("hackArmy", 5000, 1)
end
mayChangeKey = true
noticed = false
function init_6()

	API.Notify("As consequence of terror protection\nsome improvements of internet control\nhave been made. You now may send\nmessages from a false sender by\nclicking on \"Me\" in the left bottom\ncorner.")
	innerState = 0
	mayChangeKey = true
	noticed = false
	API.SetTimeout("sendMsg6", 5000, 1)

end
function gameState_6()

	if innerState == -1 then

		if API.ActiveNotification() == 0 then

			API.ChangeState(6)

		end
		return

	end
	if innerState == 0 then
		if API.ActiveNotification() == 0 then

			innerState = 1
			API.SendMsg("secretary", "president", "Sir, there are movements in Iran", 3)
		end
		return
	end
	while API.MsgAvailable("secretary") ~= 0 do

		local sender = API.MsgSender("secretary")
		local key = API.MsgKey("secretary")
		local content = API.MsgContent("secretary")


		if sender == "CA" then

			mayChangeKey = mayChangeKey and (API.MsgContent("secretary") ~= "PRESIDENTKEY did NOT expire yet")

		elseif sender ~= "president" then

			API.SendMsg("secretary", sender, "Can I help you?", key)

		elseif key ~= 3 and string.find(content, "forget") == nil then

			if noticed then

				API.SendMsg("secretary", "Me", "Got you, hacker!", 2)
				API.Notify("You have been arrested\nGAME OVER")
				API.LockNotification()
				innerState = -1

			else

				API.SendMsg("secretary", "president", "Did you forget to encrypt your message?", 2)
				noticed = true

			end

		end

		API.MsgNext("secretary")

	end
	while API.MsgAvailable("president") ~= 0 do

		local sender = API.MsgSender("president")
		local key = API.MsgKey("president")
		local content = API.MsgContent("president")


		if sender == "secretary" and key ~= 3 and string.find(content, "forget") == nil then

			if noticed then

				API.SendMsg("president", "Me", "Got you, hacker!", 2)
				API.Notify("You have been arrested\nGAME OVER")
				API.LockNotification()
				innerState = -1

			else

				API.SendMsg("president", "secretary", "Did you forget to encrypt your message?", 2)
				noticed = true

			end

		end

		API.MsgNext("president")

	end
	while API.MsgAvailable("CA") ~= 0 do
		local sender = API.MsgSender("CA")
		local content = API.MsgContent("CA")
		if API.MsgKey("CA") == 2 then

			if sender == "secretary" then

				API.SendMsg("CA", "secretary", "PRESIDENTKEY did NOT expire yet", 2)

			elseif string.find(string.lower(content), "login") ~= nil then
				API.SendMsg("CA", sender, "user=certificateAuthority;pass=whereTruePowerIs", 2)
			else
				local user, pass
				user, pass = extractLogin(content)
				if user == "certificateAuthority" and pass == "whereTruePowerIs" then
					if mayChangeKey then

						API.ChangeState(7)

					else

						API.SendMsg("CA", sender, "Login successful", 2)
					end

				else
					API.SendMsg("CA", sender, "Login required", 2)
				end
			end
		end
		API.MsgNext("CA")
	end
end
function sendMsg6()
	API.SendMsg("secretary", "CA", "did PRESIDENTKEY expire?", 2)
end
lightOn = true
dronesLogin = {}
function init_7()

	API.Notify("By getting power over the\ncertificate authority, you\nchanged PRESIDENTKEY and\ntherefore own it now.")
	API.SendMsg("CA", "secretary", "PRESIDENTKEY expired. New key is transmitted...", 2)
	API.GoOffline("CA")
	innerState = 0
	dronesLogin = {}
	lightOn = true

end
function gameState_7()

	if innerState < 0 then

		if API.ActiveNotification() == 0 then

			if innerState == -1 then

				API.ChangeState(7)

			else

				API.ChangeState(0)

			end

		end
		return

	end
	while API.MsgAvailable("secretary") ~= 0 do

		local sender = API.MsgSender("secretary")
		local key = API.MsgKey("secretary")
		local content = API.MsgContent("secretary")

		if sender == "president" then

			if key ~= 3 then

				API.SendMsg("secretary", "Me", "Got you, hacker", key)
				API.Notify("You habe been arrested.\nGAME OVER")
				API.LockNotification()
				innerState = -1

			elseif string.find(string.lower(content), "inhuman") then
				API.SendMsg("secretary", "drones", "user=whiteHouse;pass=saviorOfTheWorld", 3)
				API.SetTimeout("sendMsg7", 2000, 1)

			elseif string.find(string.lower(content), "bother") == nil then

				API.SendMsg("secretary", "president", "I'll take care of this", 3)

			end

		elseif sender == "Me" or sender == "citizen" then

			API.SendMsg("secretary", sender, "Can I help you?")

		elseif sender == "drones" then
			API.SendMsg("secretary", "Me", "Got you, hacker", key)
			API.Notify("You habe been arrested.\nGAME OVER")
			API.LockNotification()
			innerState = -1
		end
		API.MsgNext("secretary")

	end
	while API.MsgAvailable("president") ~= 0 do

		local sender = API.MsgSender("president")
		local content = API.MsgContent("president")
		local key = API.MsgKey("president")
		if sender == "secretary" then

			if key ~= 3 then
				API.SendMsg("president", "Me", "Got you, hacker", key)
				API.Notify("You habe been arrested.\nGAME OVER")
				API.LockNotification()
				innerState = -1
			elseif content ~= "I'll take care of this" then

				API.SendMsg("president", "secretary", "Stop bothering me with that irrelevant things, pls", 3)

			end

		elseif sender == "first lady" then

			API.SendMsg("president", "first lady", "Michelle, I don't have time for this, now", key)

		end
		 API.MsgNext("president")

	end
	while API.MsgAvailable("drones") ~= 0 do

		local sender = API.MsgSender("drones")
		local content = API.MsgContent("drones")
		local key = API.MsgKey("drones")
		if key == 3 then

			if dronesLogin[sender] then

				if string.find(string.lower(content), "attack") ~= nil then

					API.Notify("The war to IRAN started.\nHalf asia became a desert in\na few hours. For revange, russia throw a\nnuclear bomb over USA which makes you now\none of MANY victims.\nGAME OVER")
					API.LockNotification()
					innerState = -1

				elseif string.find(string.lower(content), "occupy") == 1 then
					local pos = string.lower(string.sub(content, 8))
					if pos == "usa" or pos == "world" or pos == "earth" then
						if sender == "Me" then
							API.Notify("You did it. The drones made\nyou to earth's dictator easily.\nNow all your people celibrate\ntheir new president.\n\nTHE END\n")
							API.LockNotification()
							innerState = -2

						else
							API.Notify("The drones made "..sender.."\nto the new dictator of the world.\nIn this process, some people had to die,\nwhich is completely normal. You are one\namong these poor victims\nGAME OVER")
							API.LockNotification()
							innerState = -1

						end
					else

						API.SendMsg("drones", sender, "Unable locate region", 3)
					end
				else
					API.SendMsg("drones", sender, "Unable to understand order", 3)
				end
			else
				local user, pass
				user, pass = extractLogin(content)
				if user == "whiteHouse" and pass == "saviorOfTheWorld" then
					dronesLogin[sender] = true
					API.SendMsg("drones", sender, "Login successful", 3)
					API.SendMsg("drones", sender, "Commands: ATTACK, OCCUPY <region>", 3)
				elseif user then
					API.SendMsg("drones", sender, "Login failed", 3)
				else
					API.SendMsg("drones", sender, "Login required", 3)
				end
			end
		end
		API.MsgNext("drones")
	end
	while API.MsgAvailable("first lady") ~= 0 do

		local key = API.MsgKey("first lady")
		if API.MsgSender("first lady") == "president" then

			API.SendMsg("first lady", "president", "Everytime, darling", key)
		else
			API.SendMsg("first lady", API.MsgSender("first lady"), "Mind your own business", key)
		end
		API.MsgNext("first lady")
	end
	while API.MsgAvailable("citizen") ~= 0 do

		API.SendMsg("citizen", API.MsgSender("citizen"), "No", API.MsgKey("citizen"))
		API.MsgNext("citizen")

	end
	while API.MsgAvailable("light") ~= 0 do

		local sender = API.MsgSender("light")
		local key = API.MsgKey("light")
		if key == 1 then

			if API.MsgSender("light") ~= "Me" then

				API.SendMsg("light", sender, "Login required/incorrect")

			else

				local content = string.lower(API.MsgContent("light"))
				if string.find(content, "switchoff") ~= nil then

					lightOn = false
					API.SetTimeout("switchLightOn", 5000, 1)
					API.Notify("You see the house turning dark again")
				elseif string.find(content, "dimto") == nil then
					API.SendMsg("light", "Me", "Unknown command", 1)
				end

			end

		end
		API.MsgNext("light")

	end
	while API.MsgAvailable("control") ~= 0 do

		local sender = API.MsgSender("control")
		local key = API.MsgKey("control")
		local content = API.MsgContent("control")
		if lightOn then

			API.SendMsg("control", sender, "Keep your dirty fingers out of this system", key)

		else

			local user, pass
			user, pass = extractLogin(content)
			if user then

				if user == "johnsmith" and pass == "1234" then

					API.SendMsg("control", sender, "Login successful")

				else

					API.SendMsg("control", sender, "Login failed")

				end

			else

				API.SendMsg("control", sender, "Login required")
			end
		end
		API.MsgNext("control")
	end
end
function sendMsg7()
	API.SendMsg("secretary", "drones", "ATTACK", 3)
end
function switchLightOn()
	API.Notify("Sombody has lighted the house again")
	lightOn = true
end

